#!/usr/bin/env node


var iGetAssertion = require('node-aws-adfs');

var readlineSync = require('readline-sync');
var argv = require('optimist').argv;
var fs = require('fs');
var os = require('os');
var oshome = os.homedir();
var ini = require('ini');

var profileini = ini.parse(fs.readFileSync(oshome + "/.aws/config", 'utf-8'))
var profile = argv.profile || "default";

// --------------------------------------------------------- //
if (!profileini[profile]) {
  // this is to stop any error messages if profile not found
  profileini[profile] = {};
  console.log(profile , " Profile not found!" );
  process.exit(0);
}
// --------------------------------------------------------- //

// --------------------------------------------------------- //
var email = argv.email || profileini[profile]["adfs_config.adfs_user"] || null;
var adfsserver = argv.adfsserver || profileini[profile]["adfs_config.adfs_host"] || null;
//var workgroup  =  argv.workgroup  || profileini[profile]["adfs_config.role_arn"]  || null ;
var workgroup = argv.workgroup || null;
var awsregion = argv.awsregion || profileini[profile]["region"] || "ap-southeast-2";
var getHelp = argv.h ||  argv.help;


if (getHelp) {
  getHelpF();
}

var tmpemail = ""

// --------------------------------------------------------- //

if (!email || profileini[profile]["adfs_config.adfs_user"]) {
  email = (setemaillogin(profileini[profile]["adfs_config.adfs_user"]))
}

if (adfsserver === null || profileini[profile]["adfs_config.adfs_host"]) {
  adfsserver = setadfsserver(profileini[profile]["adfs_config.adfs_host"])
}

// --------------------------------------------------------- //
var pass = readlineSync.question('Password:', {
  hideEchoBack: true,
});

// --------------------------------------------------------- //
if (workgroup === null) {
  var workgroup = askPassGetRoles(email, adfsserver, workgroup, awsregion);
}

// --------------------------------------------------------- //
iGetAssertion.returnAWSCredObj(
    email, pass, adfsserver, workgroup, awsregion)
  .then(function(response) {
    var configini = ini.parse(fs.readFileSync(oshome + "/.aws/credentials", 'utf-8'))

    //  response.env.EXPIRETIME = fithResult.Credentials.Expiration                 ;
    configini[profile] = {}
    configini[profile].aws_access_key_id = response.env.AWS_ACCESS_KEY_ID
    configini[profile].aws_secret_access_key = response.env.AWS_SECRET_ACCESS_KEY
    configini[profile].aws_session_token = response.env.AWS_SESSION_TOKEN
    configini[profile].aws_security_token = response.env.AWS_SECURITY_TOKEN

    fs.writeFileSync(oshome + "/.aws/credentials", ini.stringify(configini))
  })
  .catch(function(errr) {
    console.log("Error", errr)
  })

// --------------------------------------------------------- //
//                                                           //
// --------------------------------------------------------- //
function setemaillogin(tmpemail = "") {
  if (tmpemail.length) {
    var tmpemailstring = " [" + tmpemail + "]"
  } else {
    var tmpemailstring = ""
  }

  var emailout = readlineSync.question('--email ' + tmpemailstring, {
    hideEchoBack: false,
  });
  if (emailout.length == 0 && tmpemail) {
    emailout = tmpemail
  }
  if (emailout.length == 0 && tmpemail.length == 0) {
    console.log("Email loing required! please enter your email login")
    setemaillogin()
  }
  return emailout
}
// --------------------------------------------------------- //
//                                                           //
// --------------------------------------------------------- //
function setadfsserver(tmpserver = "") {
  if (tmpserver.length) {
    var tmpserver_string = " [" + tmpserver + "]"
  } else {
    var tmpserver_string = ""
  }

  var serverout = readlineSync.question('--adfsserver ' + tmpserver_string, {
    hideEchoBack: false,
  });
  if (serverout.length == 0 && tmpserver) {
    serverout = tmpserver
  }
  if (serverout.length == 0 && tmpemail.length == 0) {
    console.log("ADFS Server required!!")
    setadfsserver()
  }
  return serverout
}
// --------------------------------------------------------- //
//                                                           //
// --------------------------------------------------------- //
// Function to return the AWS Roles.
//
function askPassGetRoles(email, adfsserver, workgroup, awsregion) {
  // console.log("Get assertion with pass")
  iGetAssertion.getAWSRoles(email, pass, adfsserver, awsregion).then(function(response) {
    var index = "null"
    var slection = "";
    var size = 30;
    var pagecounter = 0;
    for (var i = 0; i < response.length; i += size) {
      var smallarray = response.slice(i, i + size);
      index = readlineSync.keyInSelect(smallarray, null, {
        cancel: 'Next page'
      });
      if (index === -1) {
        pagecounter = pagecounter + size
      } else {
        //console.log("BREAK")
        pagecounter = pagecounter + index
        break;
      }
    }

    selection = response[pagecounter]
    console.log("your selection =", selection)
    return selection

  }).catch(function(errr) {
    console.log("Error", errr)
  })
}
// --------------------------------------------------------- //
// --------------------------------------------------------- //
function getHelpF() {
  help = `
    node-aws-js -h            # help command
    node-aws-js [OPTIONS]  

    OPTIONS:
      --email      xxx@xx.com        # your ADFS login ID
      --adfsserver login.xx.com      # your ADFS loing URL
      --awsregion  ap-southeast-2    # The AWS region. ap-southeast-2 is default
      --workgroup  some-name         # The workgroup profile names (optional)
      --profile    (profilename optional)      # "default" is default value
                                               # profile in cred file will be created if not found.
      
     EXAMPLE CMD:
     To have the app ask or lookup vaules from ~/.aws/config
       node-aws-js
     
     Specify options on the command line.
       node-aws-js --email yourlogin@work.com --adfsserver login.uni.edu --workgroup POC-WORKGROUP --awsregion ap-southeast-2'
       
      FILES:
      ~/.aws/config
      ~/.aws/credentials  
  `

  console.log(help);
  process.exit(0);
}

// --------------------------------------------------------- //
// --------------------------------------------------------- //
